#include <Servo.h>
#include "TM1637.h"
#include <Adafruit_NeoPixel.h>
#define ON 1
#define OFF 0

// Which pin on the Arduino is connected to the NeoPixels?
#define PIN           8
// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS     5

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);
int pixelLed = 0;   //creat a virable to define leds.
int turnVal = 0;    //creat time interval to blink each leds.


int8_t TimeDisp[] = {0x00,0x00,0x00,0x00};
unsigned char ClockPoint = 1;
unsigned char Update;
unsigned char halfsecond = 0;
unsigned char second;
unsigned char minute = 0;
unsigned char hour = 0;
unsigned long tiktok = 0;
unsigned int serveVal = 30;
unsigned int serveUpdate = 0;
int timer = 0;

#define CLK 2//pins definitions for TM1637 and can be changed to other ports
#define DIO 3
TM1637 tm1637(CLK,DIO);

//initailize touce sensor
const int TouchPin = 4;
// initialize button state
int buttonState = 0;         // current state of the button
int lastButtonState = 0;     // previous state of the button

// initialize pomodoros
int currentPomo = 0;         
int totalPomo = 0;    

    
Servo myservo;



void setup() {
  tm1637.set(); 
  tm1637.init();
  myservo.attach(6);  
  tiktok = millis();
  serveUpdate = millis();
   pixels.begin(); // This initializes the NeoPixel library.
   pinMode(TouchPin, INPUT);
}

void loop() {
  if(millis() - tiktok >= 500)
  {
    tiktok = millis();
    clockUpdate();
    timer++;
    turnVal++;
    if(timer >= 20){
      serveVal++;
      timer = 0;
    }

  if(turnVal >= 744*pixelLed)
    {
     pixels.setPixelColor(pixelLed, pixels.Color(20,0,0)); // Moderately bright green color.
      pixels.show(); // This sends the updated pixel color to the hardware.
      pixelLed++;
   }   
 
    if(serveVal >= 180)
    {
      int x = 0;
      int k = 0;
     while(k==0 )
     {      
          if(x <= 0)
          {
          theaterChase(strip.Color(7, 7, 7), 50); // White
          theaterChase(strip.Color(7, 7, 0), 50); // Yellow
          theaterChase(strip.Color(0, 0, 7), 50); // Blue
        
                 for(int i=0;i<NUMPIXELS;i++)
                 {
                 // pixels.Color takes RGB values, from 0,0,0 up to 255,255,255
                  pixels.setPixelColor(i, pixels.Color(5,5,5)); // Moderately bright green color.
                  pixels.show(); // This sends the updated pixel color to the hardware.
                  delay(50); // Delay for a period of time (in milliseconds).
                  }
          x++;
          }
            display();
           k = digitalRead(TouchPin);
     }
     touchSR();
     display();
     delay(1000);
     k = 0;
      serveVal = 30;  
      second = 0;
      minute = 0;
      pixelLed = 0;
      turnVal = 0;
        for(int i=0;i<NUMPIXELS;i++)
                 {
                 // pixels.Color takes RGB values, from 0,0,0 up to 255,255,255
                  pixels.setPixelColor(i, pixels.Color(0,0,0)); // Moderately bright green color.
                  pixels.show(); // This sends the updated pixel color to the hardware.
                  delay(50); // Delay for a period of time (in milliseconds).
                  }
    }
  }
  
  
  if(Update == ON)
  {
    TimeUpdate();
    tm1637.display(TimeDisp);
  }

  if(millis() - serveUpdate >= 500){
    serveUpdate = millis();

    myservo.write(serveVal);  
  }
  
}

void clockUpdate()
{
  halfsecond ++;
  Update = ON;
  if(halfsecond == 2){
    second ++;
    if(second == 60)
    {
      minute ++;
      if(minute == 60)
      {
        hour ++;
        if(hour == 24)hour = 0;
        minute = 0;
      }
      second = 0;
    }
    halfsecond = 0;
  }
 // Serial.println(second);
  ClockPoint = (~ClockPoint) & 0x01;
}

void TimeUpdate(void)
{
  if(ClockPoint)tm1637.point(POINT_ON);
  else tm1637.point(POINT_OFF);
  TimeDisp[0] = minute / 10;
  TimeDisp[1] = minute % 10;
  TimeDisp[2] = second / 10;
  TimeDisp[3] = second % 10;
  Update = OFF;
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();
     
      delay(wait);
     
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

void touchSR()
{
  unsigned long timeStart = millis();
  unsigned long  duration = 0;
  
  while(digitalRead(TouchPin)){
    if(millis() - timeStart >= 2000){
       currentPomo++;
      totalPomo = currentPomo +totalPomo;
      currentPomo = 0;
     
      break;
    }
  }
  duration = millis() - timeStart;
  if(duration <= 1000){
    currentPomo++;
  }
}

void display()
{
   tm1637.display(0,currentPomo / 10);
   tm1637.display(1,currentPomo % 10);
   tm1637.display(2,totalPomo / 10);
   tm1637.display(3,totalPomo % 10);
}

